/* $Log: application_layer.c,v $
 * Revision 1.3  96/08/27  14:01:48  shivkuma
 * More bugs in Mickey fixed
 * 
 * Revision 1.2  96/08/26  15:09:16  shivkuma
 * Added mickey mouse to lab3
 * 
 * Revision 1.1  96/07/12  20:51:28  tlin
 * Initial revision
 * 
 * Revision 0.0  96/04/26  15:37:26  goyal
 * Lab1
 * 
 * Revision 0.0  96/04/26  15:30:44  goyal
 * Lab1
 * 
 * Revision 0.0  96/04/26  15:01:43  goyal
 * Lab1
 * 
 * Revision 0.0  96/04/26  14:57:33  goyal
 * Lab1
 * 
 * Revision 0.0  96/04/26  14:54:21  goyal
 * Lab1
 * 
 * Revision 0.0  96/04/26  14:53:45  goyal
 * Lab1
 * 
 * Revision 0.0  96/04/26  14:46:10  goyal
 * Lab1
 * 
 * Revision 0.0  96/04/26  14:44:45  goyal
 * Lab1
 * 
 * Revision 0.0  96/04/26  14:44:10  goyal
 * Lab1
 * 
 * Revision 1.2  96/04/25  16:57:23  tlin
 * different colors for packets from different layers
 * 
 * Revision 1.1  96/04/25  16:18:51  tlin
 * LOAD fixed
 * 
 * Revision 1.0  96/04/24  14:54:40  shivkuma
 * Lab 1
 *  
 */

#include "cisePort.h"
#include "sim.h"
#include "list.h"
#include "main.h"
#include "route_activity.h"
#include "application_layer.h"
/* ------------------- MACRO DEFINITIONS/WRAPPERS -------------- */
#include "application_layer_wrappers.c"

caddr_t
application_layer_action(src,cn1,type,pdu,arg)
     Component *src;
     void *cn1;
     int type;
     PDU_TYPE *pdu;
     caddr_t arg;

{
  
   caddr_t result = NULL;
   APPLICATION_LAYER_ENTITY_TYPE *cn;
   cn = cn1;

   switch (type)  {

   case MY_SEND_A_PDU:
      result = cn_send(cn,arg);  
      break;

   case EV_RECEIVE:
      result = cn_receive(cn,pdu);
      break;

   case EV_READY:
	cn->stop = 0;
        if (cn->stalled_data) cn_send(cn,cn->stalled_data);
	cn->stalled_data = NULL;
	result = (caddr_t) cn;
	break;
	
   case EV_BUSY:
	cn->stop = 1;
	result = (caddr_t) cn;
	break;
	
   app_other_event_handlers();
   
   default:
      break;


    }

  return(result);
}

/*****************************************/
static caddr_t cn_send(register APPLICATION_LAYER_ENTITY_TYPE *cn, char *data)
{
  tick_t interval;
  int i;
  tick_t time;
  Neighbor *n;
  int space;
  PDU_TYPE *pdu;
  
  
  if (USECS_TO_TICKS(pval(cn, cn_start_time)->u.d) <= ev_now() ) {   
    
    if ((cn->cn_num_sent < (pval(cn,cn_trans_size)->u.d*1000000/A_PDU_SIZE/8))
	&& (USECS_TO_TICKS(pval(cn, cn_stop_time)->u.d) > ev_now()) ) {

	 if(!cn->stop){
	      time = ev_now();

	      n = ((Neighbor *) cn->cn_neighbors->l_head);
	      space = (n->n_c->iq_limit - n->n_c->iq_length);
      
      /* RG: space is always available in the DLC */
	      if(space > 0){
		   pdu = pdu_alloc(); 
		   pdu->type = TYPE_IS_A_PDU;
		   pdu->u.a_pdu.snode = 
			get_number_from_string(cn->cn_name);
	
		   pdu->u.a_pdu.dnode = (int) cn->cn_destination->u.d;
		   if (M.doX) {
			if (data) {
			     memcpy(pdu->u.a_pdu.data, data, DATASIZE);
			     if (data[0]=='G') {
				  interval=
				       USECS_TO_TICKS(((A_PDU_SIZE*8.0)/
						  (pval(cn,cn_bit_rate)->u.d)));
				  Cise_SendBulk1(data, interval);
			     }
			     free(data);
			} else {
			  memcpy(pdu->u.a_pdu.data,"MInitial message",DATASIZE);
			}
		   } else {
			/* sends junk data when not doX */
		   } 

		   /* if (M.doX)
		     			route_activity((Component*)cn,
				       (Neighbor*)cn->cn_neighbors->l_head)->n_c, 
				       10, 1, 0); 
				       */
	
		   ev_enqueue(EV_RECEIVE, (Component *)cn, 
			      ((Neighbor *) cn->cn_neighbors->l_head)->n_c,
			      ev_now()+10,
			      (((Neighbor *) cn->cn_neighbors->l_head)->n_c->co_action), 
			      (PDU_TYPE *) pdu, (caddr_t)NULL);
	      } /* if (space > 0) */

	 } /* if (!cn->stop) */
         else if (data && data[0]=='G'){
	     cn->stalled_data = data; 
	 }
	      
	 if (!M.doX) {
	      /* Calculate the next pdu generation time */
	      interval=
		USECS_TO_TICKS(((A_PDU_SIZE*8.0)/(pval(cn,cn_bit_rate)->u.d)));	
	     /* schedule a pdu to be generated at that time */
	      ev_enqueue(MY_SEND_A_PDU, (Component *)cn, (Component *)cn,
			 ev_now()+interval,application_layer_action,
			 (PDU_TYPE *)NULL, (caddr_t)NULL);
	 }
	 cn->cn_num_sent++;
    } /* conditions for send ok */
 } else {
 
   interval = USECS_TO_TICKS(pval(cn, cn_start_time)->u.d);
   ev_enqueue(EV_START, (Component *)cn, (Component *)cn, 
	      interval, application_layer_action,
	      (PDU_TYPE *)NULL,(caddr_t)NULL);
 } 
                   


  return ((caddr_t)cn);
}

/********************************************************************/
static caddr_t
cn_receive(cn, pdu)
    register APPLICATION_LAYER_ENTITY_TYPE *cn;
    register PDU_TYPE *pdu;
{
	cn->cn_pkts_recvd->u.i += 1;
	log_param((Component *)cn, pval(cn, cn_pkts_recvd));

/* printf("node %s: received msg %s\n", cn->cn_name, pdu->u.a_pdu.data); */
	if (M.doX) 
	  cise_recv_msg(cn->cn_name,pdu->u.a_pdu.data);

	pdu_free(pdu);
	   
	return ((caddr_t)cn);
}


/********************************************************************/

