#ifndef DLC_CONN_INF_H
#define DLC_CONN_INF_H


#define MAXWIN 1
#define MAXBUFFER 7
#define MAXCONNECTIONS 4

/* PDU_BUFFER_TYPE is a blackbox: Managed by InsertPDU, RemovePDU, and
	       FreeBuffers */
     
typedef struct{
    int buffer_index; /*  Index of last PDU in buffer */
    int buffers_available; /* Number of buffers available */
    int snd_una_shadow;  /* Shadows the snd_una variable in the
			    (possibly larger) buffer */
     PDU_TYPE buf[MAXBUFFER]; /* Retransmission buffer */
} PDU_BUFFER_TYPE; 

     
typedef struct {
    int snd_nxt,    /* Sequence number of next D_PDU to be sent */
        snd_una,    /* Sequence number of the first unacknowledged D_PDU */
        rcv_nxt,    /* Sequence number of next D_PDU expected to be received */
        nak_already_sent, /* 0 => Can send Nack. 1 => Can't send Nak */
        window_size; /* Window size for go-back-N. Initialized to MAXWIN. */


    Event *timer_event;
     
    PDU_BUFFER_TYPE pdu_buffer;  /* Blackbox: Interface is:
				     InsertPDUIntoBuffer(),
				     UpdatePDUBuffer(),
				     DataInPDUBuffer() */
     
     
} DLC_Conn_Info_TYPE;


     


#endif






