/* ------------- WRAPPERS FOR THE DLC_LAYER CODE ---------- */
/* --- Please do not modify this file. --------- */
/* --- Any doubts, send email to shivkuma@cis.ohio-state.edu
   ----- */

extern Log pkt_log;
/****************************************/

static caddr_t cn_reset(),cn_create(),cn_neighbor(),
               cn_uneighbor(),cn_route(),cn_hops(),cn_send(),cn_start();
/* $Revision: 1.1 $ */
static int window_open();

/* $Revision: 1.1 $ : in file dlc_layer.c */

static
dlc_layer_receive(), DatalinkProcessError(), DatalinkProcessACK(),
     DatalinkProcessNAK(), DatalinkProcessInfo(), DatalinkTimerExpired(),
     AttemptToSend(), SendAck(), SendNak(), DatalinkToPhysical();
static 
send_pdu_to_physical_layer(), my_send_pdu_to_physical_layer();
/* $Revision: 1.1 $ : in file dlc_layer_wrappers.c */
static DLC_Conn_Info_TYPE *Datalink_Get_Conn_Info();
static SetTimer1(), InsertPDUIntoBuffer(), UpdatePDUBuffer();
static PDU_TYPE *GetPDUFromBuffer();

/* $Revision: 1.1 $ : Lab2 requires timers */
#define RETRANSMISSION_TIMEOUT (EV_CLASS_PRIVATE | 1)
/* To allow sending at future instants */
#define MY_SEND (Evtype)(EV_CLASS_PRIVATE | 2)

/* Wrappers */

/****************************************/

#define dlc_other_event_handlers()                      \
{							\
  case EV_RESET:					\
  {							\
       cn->last_pdu_time = 0;				\
       cn->cn_iq_length = 0;				\
       cn->cn_iq_limit = 1;				\
       result=(caddr_t)cn;				\
       break;						\
  }							\
  case EV_CREATE:					\
       result = cn_create((char *)arg);			\
       break; 						\
  case EV_DEL:						\
       comp_delete((Component *)cn);			\
       result = (caddr_t)cn;				\
       break;						\
  case EV_NEIGHBOR:					\
       result = cn_neighbor(cn, (Component *)arg);	\
       break;						\
  case EV_UNEIGHBOR:					\
       result = cn_uneighbor(cn, (Component *)arg);	\
       break;						\
  case EV_LEGAL_NEXT_HOPS:				\
       result = cn_hops(cn);				\
       break;						\
  case EV_MAKE_ROUTE:					\
       result = cn_route(cn, (list *)arg);		\
       break;						\
  case EV_START:					\
       result = cn_start(cn);                           \
       break;						\
  case EV_UPDATE_ROUTE_ACTIVITY:			\
       update_routes(src,(Component *)cn);              \
       result=(caddr_t)cn;				\
       break;						\
 case MY_SEND:                                          \
       my_send_pdu_to_physical_layer(cn,pdu);           \
       result=(caddr_t)cn;				\
       break;						\
 						        \
}
/****************************************/

/****************************************/

caddr_t dlc_layer_action(Component *src,
			 void *cn1,
			 int type,
			 PDU_TYPE *pdu,
			 caddr_t arg)
{
     caddr_t result = NULL;	 
     DLCConnectiont  *cn;
	 cn = (DLCConnectiont *)cn1;

     switch (type)  {

     case EV_RECEIVE:
	  dlc_layer_receive(cn,src,pdu);				 
	  result = (caddr_t)cn;
	  break;

	  /* $Revision: 1.1 $ : Timout Handler */
     case RETRANSMISSION_TIMEOUT:
	  DatalinkTimerExpired(cn,(DLC_Conn_Info_TYPE *)arg);
	  result = (caddr_t)cn;
	  break;

	  dlc_other_event_handlers();
	  
     default:
	  break;			  
     }					    
     return(result);			      
}

/****************************************/
#define DatalinkFromApplication(src) ((src)->co_class == APP_CLASS)
#define DatalinkFromPhysical(src) ((src)->co_class == PHY_CLASS)
/****************************************/

static 
send_pdu_to_physical_layer(DLCConnectiont *cn,PDU_TYPE *pdu)
{
     tick_t this_pdu_time = Maxm(cn->last_pdu_time,ev_now());
 
     ev_enqueue(MY_SEND, (Component *)cn,(Component *)cn,
		this_pdu_time,
		cn->cn_action, (PDU_TYPE *) pdu,
		(caddr_t)NULL);

     /* 100000 ticks gap between packets */
     cn->last_pdu_time = this_pdu_time + 100000; 
     return 0;
}

/****************************************/
static my_send_pdu_to_physical_layer(DLCConnectiont *cn,PDU_TYPE *pdu)
{
        Neighbor *n;
     
	for (n=(Neighbor *)cn->cn_neighbors->l_head;n;n=n->n_next)
	     if (n->n_c->co_class == PHY_CLASS)
		  break;
	/*
	if (M.doX)
	     route_activity((Component *)cn, n->n_c, 10, 2, 0);
	     */
	
	ev_enqueue(EV_RECEIVE, (Component *)cn, n->n_c, ev_now()+10,
		   n->n_c->co_action, (PDU_TYPE *) pdu,
		   (caddr_t)NULL);

	return 0;
}

/****************************************/
#define send_pdu_to_application_layer(cn,pdu)				\
{									\
      Neighbor *n;							\
      for (n=(Neighbor *)cn->cn_neighbors->l_head;n;n=n->n_next) {	\
	  if (n->n_c->co_class == APP_CLASS)				\
	       break;							\
     }									\
     ev_enqueue(EV_RECEIVE, (Component *)cn, n->n_c, ev_now()+10,	\
		n->n_c->co_action, (PDU_TYPE *) pdu,	\
		(caddr_t)NULL);						\
}

/*
       if (doXstuff && screen_update == ON) 				\
	  route_activity((Component *)cn, n->n_c, 10,ev_now());		\

 */

/****************************************/

#define DLC_LAYER_ENTITY_TYPE DLCConnectiont
#define GENERIC_LAYER_ENTITY_TYPE Component

/****************************************/
/* ------------- $Revision: 1.1 $: Lab2 Wrappers ------------------ */

/* -------- The following function depends upon the routing assumption that
   there is exactly one connection to any node, and uses the node address to
   index into the Conn_info table.
   ------ */

static DLC_Conn_Info_TYPE *
Datalink_Get_Conn_Info(DLCConnectiont *cn,PDU_TYPE *pdu)
{
DLC_Conn_Info_TYPE *dci;
int i;

i = ((pdu->type == TYPE_IS_D_PDU) ? (pdu->u.d_pdu.curr_node) : (pdu->u.a_pdu.dnode));
     
dci = &(cn->DLC_Conn_Info[i]);

return dci;
}
/****************************************/

/* --------- $Revision: 1.1 $: Lab2: Timeout etc ------- */
#define TIMEOUT_INTERVAL 1000 /* 1ms timeout */

/****************************************/
static
SetTimer1(DLCConnectiont *cn, DLC_Conn_Info_TYPE *dci)
{
     tick_t timeout = USECS_TO_TICKS(TIMEOUT_INTERVAL);
     
     if(dci->snd_una != dci->snd_nxt) /* Some timer outstanding for this
					 connection => dequeue
				         old timer and enqueue new timer */
	  ev_dequeue(dci->timer_event);
/*	       _by_comp_and_type_and_arg(cn,cn,RETRANSMISSION_TIMEOUT,
					      (caddr_t) dci);*/

     dci->timer_event = ev_enqueue(RETRANSMISSION_TIMEOUT, (Component *)cn,
				   (Component *)cn,
				   ev_now()+timeout, cn->cn_action,
				   (PDU_TYPE *) NULL, (caddr_t)dci); 

     
return 0;
}

/****************************************/

/* ************* $Revision: 1.1 $: Initialize DLC_Conn_Info ******** */
static caddr_t
cn_start(DLCConnectiont *cn)
{
int i;

for(i=0;i<MAXCONNECTIONS;i++){
     cn->DLC_Conn_Info[i].window_size = MAXWIN;
     cn->DLC_Conn_Info[i].pdu_buffer.buffer_index = 0;
     cn->DLC_Conn_Info[i].pdu_buffer.buffers_available = MAXBUFFER;
     cn->DLC_Conn_Info[i].pdu_buffer.snd_una_shadow = 0;
     cn->DLC_Conn_Info[i].snd_nxt = 0;
     cn->DLC_Conn_Info[i].snd_una = 0;
     cn->DLC_Conn_Info[i].rcv_nxt = 0;
     cn->DLC_Conn_Info[i].nak_already_sent = 0;
     cn->DLC_Conn_Info[i].timer_event = (Event *) NULL;
}
     
     
 return((caddr_t)cn);
}
/****************************************/
/* ************ Buffer Management Routines *************** */
static
InsertPDUIntoBuffer(DLCConnectiont *cn, PDU_TYPE *pdu, DLC_Conn_Info_TYPE *dci)
{
int i;
Neighbor *n;


if (dci->pdu_buffer.buffers_available > 0){

      dprintf(1, "Time = %8.2f us: InsertPDU: %s: snd_nxt = %d, snd_una = %d,\n	 \
                  rcv_nxt = %d, buf_index = %d, buf_avail = %d, una_shadow = %d\n",
		 ev_now()/1000.0, cn->cn_name, dci->snd_nxt, dci->snd_una,
	         dci->rcv_nxt, dci->pdu_buffer.buffer_index, dci->pdu_buffer.buffers_available,
	         dci->pdu_buffer.snd_una_shadow);
     fflush(stdout);

     
     i = dci->pdu_buffer.buffer_index;
     dci->pdu_buffer.buffer_index =
	  (dci->pdu_buffer.buffer_index + 1)%MAXBUFFER;


     bcopy((char *)pdu,(char *)&(dci->pdu_buffer.buf[i]), sizeof(PDU_TYPE));

     dci->pdu_buffer.buffers_available--;

}

/* Stop application if necessary here */

if(dci->pdu_buffer.buffers_available == 0){
for (n=(Neighbor *)cn->cn_neighbors->l_head;n;n=n->n_next) {
     if (n->n_c->co_class == APP_CLASS)
	  break;
}

ev_enqueue(EV_BUSY, (Component *)cn, n->n_c, ev_now(),
		n->n_c->co_action, (PDU_TYPE *) NULL,
		(caddr_t)NULL);

}
pdu_free(pdu); 
return 0;
     
}

/****************************************/
static
UpdatePDUBuffer(DLCConnectiont *cn, PDU_TYPE *pdu, DLC_Conn_Info_TYPE *dci)
{
int n_pdus_acked;
Neighbor *n;
int occupied_window;

/* Nothing to update for duplicate acks  */
if (pdu->u.d_pdu.ack_number == dci->snd_una) return 0;

if (pdu->u.d_pdu.ack_number > dci->snd_una){
     n_pdus_acked = pdu->u.d_pdu.ack_number - dci->snd_una;
}
else{
     n_pdus_acked = pdu->u.d_pdu.ack_number + dci->window_size + 1 - dci->snd_una;
}
/* $Revision$ : Sanity Check : may catch a few out of order ACKs */

occupied_window = ((dci->snd_nxt >= dci->snd_una) ?
		   (dci->snd_nxt - dci->snd_una) :
		   (dci->snd_nxt + dci->window_size + 1 - dci->snd_una));

if (occupied_window < n_pdus_acked) return 0; 

dci->pdu_buffer.buffers_available += n_pdus_acked; /* Buffers available */
dci->pdu_buffer.snd_una_shadow = (dci->pdu_buffer.snd_una_shadow + n_pdus_acked)%MAXBUFFER; /* The shadow moves ... */

  dprintf(1, "Time = %8.2f us: UpdatePDU: %s: snd_nxt = %d, snd_una = %d,\n	 \
              rcv_nxt = %d, buf_index = %d, buf_avail = %d, una_shadow = %d,\n	\
              npdus=%d, ack_number=%d\n",
		 ev_now()/1000.0, cn->cn_name, dci->snd_nxt, dci->snd_una,
	         dci->rcv_nxt, dci->pdu_buffer.buffer_index,
	  dci->pdu_buffer.buffers_available, dci->pdu_buffer.snd_una_shadow,
	  n_pdus_acked, pdu->u.d_pdu.ack_number);
     fflush(stdout);

/* Inform higher layer */

for (n=(Neighbor *)cn->cn_neighbors->l_head;n;n=n->n_next) {
     if (n->n_c->co_class == APP_CLASS)
	  break;
}

ev_enqueue(EV_READY, (Component *)cn, n->n_c, ev_now(),
		n->n_c->co_action, (PDU_TYPE *) NULL,
		(caddr_t)NULL);

return 0;
}
/****************************************/

#define DataInPDUBuffer(dci) (MAXBUFFER - dci->pdu_buffer.buffers_available)

/****************************************/

static PDU_TYPE *
GetPDUFromBuffer(DLC_Conn_Info_TYPE *dci)
{
int occupied_window,i;

occupied_window = ((dci->snd_nxt >= dci->snd_una) ?
		   (dci->snd_nxt - dci->snd_una) :
		   (dci->snd_nxt + dci->window_size + 1 - dci->snd_una));     

i = ((dci->pdu_buffer.snd_una_shadow + occupied_window)%(MAXBUFFER));

return (&(dci->pdu_buffer.buf[i]));
}

/* ***************** OLDER FUNCTIONS **************** */

/****************************************/
static caddr_t
cn_create(name)
     register char *name;
{
    DLCConnectiont *newcn;

   /* Memory for the component structure. */
   newcn = (DLCConnectiont *)sim_malloc(sizeof(DLCConnectiont));

   /* First things first-- copy name into the new structure. */
   strncpy(newcn->cn_name, name, 40);

   /* have to create a neighbor list */
  newcn->cn_neighbors= l_create();
  newcn->cn_params = q_create();
  newcn->cn_type = DLC_LAYER_TYPE;
  newcn->cn_class = DLC_CLASS;
  newcn->cn_action = dlc_layer_action;
  newcn->cn_menu_up = FALSE;
  newcn->cn_flash = 0;

 /* Initialize the parameters */
  newcn->cn_Name = param_init ((Component*)newcn, "Name",
             (PFD)NULL, make_name_text, make_short_name_text,
             param_input_name,
             0, DisplayMask | InputMask | CanHaveLogMask, 0.0);

   return((caddr_t)newcn);
}

/****************************************/
static caddr_t
cn_neighbor(cn,c)
     register DLCConnectiont *cn;
     register Component *c;
{
     register Neighbor *n;
    if (!(n=add_neighbor((Component*)cn,c,2,2,APP_CLASS,PHY_CLASS)))
        return ((caddr_t)NULL);
    return ((caddr_t)n);
}

/*****************************************/
static caddr_t
cn_uneighbor(cn,c)
   register DLCConnectiont *cn;
   register Component *c;
{
   return ((caddr_t)remove_neighbor((Component *)cn,c));
}

/******************************************/

static caddr_t
cn_hops(cn,l)
   register DLCConnectiont *cn;
   list *l;
{


    register list *nlist;
    register Neighbor *n;
    register Component *c;

/* what is legal for the next hop depends on the type of the previous
   hop. If the previous one is a link, then the next must be a connection.
   If the previous one is a connection, the next one may be either a link
   or a connection.
   (Allowing a connection with both ends at the same bte ) */

   /* The previous step in the route = tail of list is put in c */
   c = (Component *)(l->l_tail->le_data);

   /* Make an empty list */
   nlist = l_create();

   /* Put appropriate neighbors into list */
   for (n=(Neighbor *)cn->cn_neighbors->l_head;n;n=n->n_next)
       if (n->n_c!=c && ((c->co_class == APP_CLASS) ||
           (c->co_class == PHY_CLASS && n->n_c->co_class == APP_CLASS)))
            l_addt(nlist,(caddr_t)n->n_c);


    return ((caddr_t)nlist);


}

/*******************************************/
static caddr_t
cn_route(cn,route_list)
         register DLCConnectiont *cn;
         list *route_list;
{

#ifdef NOTDEF
         Param *p;
         Component *this_component;
         Component *other_component;
         Neighbor *n1;
         Neighbor *n2;
    

         p=param_init((Component *)cn,"Other End Connection :               ",
                      int_calc,make_int_text,make_short_int_text,
                      (PFI)NULL,0,DisplayMask | CanHaveLogMask,0.0);

        if ((((Component *)route_list->l_head->le_data)->co_name[3] !=
              cn->cn_name[3]) || 
             (((Component *)route_list->l_head->le_data)->co_name[2] !=
              cn->cn_name[2]) || 
              (((Component *)route_list->l_head->le_data)->co_name[1] !=
              cn->cn_name[1]) || 
              (((Component *)route_list->l_head->le_data)->co_name[0] !=
              cn->cn_name[0]) ) 
            strcat(p->p_name,((Component *)route_list->l_head->le_data)->
                              co_name);
        else strcat(p->p_name,((Component *)route_list->l_tail->le_data)->
                               co_name);
 
         cn->cn_vpi=vpi;

         this_component = (Component *)route_list->l_head->le_data;
         other_component = (Component *)route_list->l_tail->le_data ;      

         n1= (Neighbor *)this_component->co_neighbors->l_head;
         n2= (Neighbor *)other_component->co_neighbors->l_head;

         if (n1->n_c->co_name[3] == n2->n_c->co_name[3])
            cn->cn_simple_connection=1;
         

           return ((caddr_t)cn); /* return something non-null */
#endif
}
 
/********************************************************************/

