/* $Log:	link.c,v $
 * Revision 1.5  96/08/29  15:11:56  tlin
 * add frame_type in cn_receive()
 * 
 * Revision 1.4  1996/08/29 10:21:11  shivkuma
 * More Mickey mouse fixes
 *
 * Revision 1.3  96/08/27  14:01:55  shivkuma
 * More bugs in Mickey fixed
 * 
 * Revision 1.2  96/08/26  16:13:46  shivkuma
 * Added mickey mouse to lab3
 * 
 * Revision 1.1  96/07/12  20:51:28  tlin
 * Initial revision
 * 
 * Revision 1.0  96/04/24  14:54:44  shivkuma
 * Lab 1
 *  */


#include "cisePort.h"
#include "sim.h"
#include "list.h"
#include "main.h"
#include "route_activity.h"
#include "link.h"
#include "physical_layer.h"
/* ------------------- MACRO DEFINITIONS/WRAPPERS -------------- */
#include "link_wrappers.c"


#define PHYSICAL_LAYER_ENTITY_TYPE PHYConnectiont

/*
static FILE *mfp[100];
static int tr_count=0;
static int trace_no=0;
static char fname[6] = "trace";
static Event *alln = NULL;
char namecall[30]; 
*/
static Event *alln = NULL;

/* defined in main.C */
#define  MaxCollision 20           
extern float interface_array[];	
extern int collision_array[];		     

caddr_t
link_action(src,cn1,type,pdu,arg)
     Component *src;
     void *cn1;
     int type;
     PDU_TYPE *pdu;
     caddr_t arg;
     
{

   caddr_t result = NULL;
   LINK_ENTITY_TYPE *cn;
   cn = (LINK_ENTITY_TYPE *) cn1;

   switch (type)  {


   case EV_CARRIER_SENSE:
	result = cn_carrier_sense(cn, src, (int) arg);
	break;
	
   case EV_RECEIVE:  /* Data Send Request */
     
      result = cn_receive(cn,src,pdu,(int) arg);
      break;

   case CHK_XMN_STATUS:
	result = cn_check_transmission_status(cn, src, pdu, (int) arg);
	break;

   case COLLISION_DETECT_NOTIFY:
	result = cn_collision_detect_notify(cn, pdu,(int) arg);
	break;


   case LINE_CLEAR_AFCOLL:
	result = cn_line_clear_afcoll(cn);
	break;

 case LINE_CLEAR_AFTRAN:
	result = cn_line_clear_aftran(cn, (int)arg);
	break;

   case STOP_GRAPHIC:
        result = cn_stop_graphic(cn,src,pdu,(int)arg);
	break;
	

   case UPDATE_INTERFACE:
        result = cn_update_interface(cn,(int)arg);
	break;
  
      link_other_event_handlers();
   
   default:
      break;


    }

  return(result);
}

/********************************************************************/











 /*********************************************************************/



static caddr_t
cn_carrier_sense(cn,src, i)
    register LINK_ENTITY_TYPE *cn;
    Component *src;



    /*PHYSICAL_LAYER_ENTITY_TYPE *src;*/



    int i; /* index in the array */
    
{
     Component *c = cn->node[i].c;
     int kot = 1;
                      
     /*	 strncpy(namecall,"CfreeCHECK",10);      
		      trace(cn,i); */ 
    



     cn->node[i].Waiting = TRUE;
    




     if (c && cn->node[i].Signal_Arrival_Time > ev_now() ) {
	  ev_enqueue(EV_CARRIER_FREE, (Component *)cn,
		     (Component *) c,
		     ev_now(), c->co_action, (PDU_TYPE *) NULL, (caddr_t) i);

		      cn->node[i].Waiting = FALSE;
		 kot = 0;     
		
		 /*   
		  strncpy(namecall,"CfreISFREE",10);
                      
		      
		      trace(cn,i);            
		      */ 

     }
     if (kot==1){
       /*
	  strncpy(namecall,"CrrNotFree",10);
          trace(cn,i); */
     }  
   return ((caddr_t)cn);    
}
/********************************************************************/

static caddr_t
cn_stop_graphic(cn,src,pdu,i)
    register LINK_ENTITY_TYPE *cn;
    

    Component *src;
    PDU_TYPE *pdu;
    int i; /* index in the array */
{
 Component *c = cn->node[i].c;
 int j = cn->findindex[pdu->u.d_pdu.next_node];
 int k;
 Component *d = cn->node[j].c;
 

 

 if(M.doX){
	    if(i!=j){
	    
      stop_sending_packet((Component *)c, (Component *)d);
	  }
 }  



   return ((caddr_t)cn);    
}




/*******************************************************************/
static caddr_t
cn_check_transmission_status(cn,src,pdu,i)
    register LINK_ENTITY_TYPE *cn;
    Component *src;
    PDU_TYPE *pdu;
    int i; /* index in the array */
{
 Component *c = cn->node[i].c;
 int j = cn->findindex[pdu->u.d_pdu.next_node];
 int k;
 Component *d = cn->node[j].c;
 PDU_TYPE *p;
 int qq;
      
     if(!cn->Collision_On_Link && c && d &&
	(cn->node[i].EndTx != (tick_t) INFINITY)){

       /* This event is done after the line clarity is checked */ 

   ev_enqueue(EV_SUCCESSFUL_XMIT, (Component *)cn,
	 	     (Component *) c,
		      (cn->node[i].EndTx + USECS_TO_TICKS(9.6) ), c->co_action,
			      (PDU_TYPE *) pdu, (caddr_t) i);
  

 ev_enqueue(STOP_GRAPHIC, (Component *)cn,
				       (Component *) cn,
			      (cn->node[i].EndTx),
				       cn->cn_action,
				       (PDU_TYPE *) pdu, (caddr_t) i);







 /*
	 strncpy(namecall,"TranSuccs1",10);
       trace(cn,i);     
       */  
	  ev_enqueue(EV_RECEIVE, (Component *)cn,
		     (Component *) d,
		     (cn->node[i].EndTx + cn->Propogation_Time[i][j] + USECS_TO_TICKS(9.6) ),
			     d->co_action, (PDU_TYPE *) pdu, (caddr_t) j);

		  cn->Collision_On_Link = FALSE;
		  cn->Collision_Clear_Time = (tick_t)INFINITY;   
                  qq = 1;
		  for (k=1;k<=cn->num_nodes;k++){
		       if(cn->node[k].c){
			 /*  p=pdu_alloc();  */
 			 /*   p->type = i; */
			 /* Hack: pass "i" thru the type field */
			    
			    ev_enqueue(LINE_CLEAR_AFTRAN, (Component *)cn,
				       (Component *) cn,
			      (cn->node[i].EndTx + cn->Propogation_Time[i][k]),
				       cn->cn_action,
				       (PDU_TYPE *) NULL, (caddr_t) k);
			   

     

		       } /* IF */	
		  } /* FOR */
		  
     
     } /* IF */
     /*
       strncpy(namecall,"Check_Tras",10);
       trace(cn,i);
       */
   return ((caddr_t)cn);    
}
/********************************************************************/

static caddr_t
cn_collision_detect_notify(cn, pdu,i)
     register LINK_ENTITY_TYPE *cn;
       PDU_TYPE *pdu;
    int i; /* index in the array */

{
  int j;
  tick_t rtt;
   Component *d;
   Component *Newd =  cn->node[i].d;
  Component *c = cn->node[i].c;
  rtt = USECS_TO_TICKS(cn->cn_delay->u.d);
 
     if( ev_now() == cn->node[i].Collision_Detection_Time){
	  ev_enqueue(EV_COLLISION_DETECT, (Component *)cn,
		     (Component *) c, ev_now(), c->co_action,
		     (PDU_TYPE *) NULL, (caddr_t) i);
	  
	  j = cn->findindex[pdu->u.d_pdu.next_node];
	
	  /* Destination id in pdu */
	  d = cn->node[j].c;
	  


	  
	  if(M.doX){
	    if(i!=j){
	      
      stop_sending_packet((Component *)c, (Component *)Newd);
	  }
	  }   

      // This will cause error, pdu will be used later, can't 
	  // delete at this time.
	 /* pdu_free(pdu); */

	   
	   

     }


 

         if (!alln) {
        alln =  ev_enqueue(LINE_CLEAR_AFCOLL, (Component *)cn,
		     (Component *) cn, (ev_now() + rtt +  USECS_TO_TICKS(3.2)) , cn->cn_action,
		     (PDU_TYPE *) NULL, (caddr_t) i);
               
     } 

    



	 /*
	     strncpy(namecall, "coll_det_n",10);

	    trace(cn,i);
	    */
     return ((caddr_t)cn);    
}

/********************************************************************/

static caddr_t
cn_line_clear_aftran(cn,i)
    register LINK_ENTITY_TYPE *cn;
    int i; /* index in the array */
{
  Component *c = cn->node[i].c;
   
    cn->node[i].Signal_Arrival_Time = cn->node[i].Tmp_Signal_Arrival_Time;
    cn->node[i].Tmp_Signal_Arrival_Time = INFINITY;
    cn->node[i].EndTx = INFINITY;
    cn->node[i].Node_Transmitting = FALSE;
    
    if(cn->node[i].Waiting && cn->node[i].Signal_Arrival_Time > ev_now()+ USECS_TO_TICKS(9.6)){
     
 

     ev_enqueue(EV_CARRIER_FREE, (Component *)cn,
		     (Component *) c,
		     (ev_now()+  USECS_TO_TICKS(9.6)) , c->co_action,
			     (PDU_TYPE *) NULL, (caddr_t) i); 
		 cn->node[i].Waiting = FALSE;
		 
		 /*
          strncpy(namecall, "co_cl_aftr",10);   
        
        trace(cn,i);
	*/

    }	 
    
     return ((caddr_t)cn); 
   
}


/********************************************************************/

static caddr_t
cn_line_clear_afcoll(cn)
    register LINK_ENTITY_TYPE *cn;
    
    
{
  
 
  int k;
  /* Component *c = cn->node[k].c;*/
 Component *c;
  alln = NULL;
   cn->Collision_On_Link = FALSE;
     for (k=1;k<=cn->num_nodes;k++){
		       if(cn->node[k].c){
			 c = cn->node[k].c;
			 cn->node[k].Collision_Detected = FALSE;
			 cn->node[k].Collision_Detection_Time = INFINITY;
			 cn->node[k].Node_Transmitting = FALSE;
			 cn->node[k].EndTx = INFINITY;
			 cn->node[k].Signal_Arrival_Time =  INFINITY;
                         cn->node[k].Tmp_Signal_Arrival_Time = INFINITY;
			 	 if (cn->node[k].Waiting){ 
			   
				     ev_enqueue(EV_CARRIER_FREE, (Component *)cn,
				       (Component *) c,
				       (ev_now() +  USECS_TO_TICKS(9.6)), c->co_action,
					(PDU_TYPE *) NULL, (caddr_t) k); 

		


			   

			   cn->node[k].Waiting = FALSE;
                            
			    		 } 
		       }

		       /*
      strncpy(namecall, "co_cl_afco",10);
                            trace(cn,k); 
			    */
     } /*FOR*/
     

     reset_collision_arrays();
    
  
  return ((caddr_t)cn); 

}




/********************************************************************/


static caddr_t
cn_receive(cn,src, pdu,i)
    register LINK_ENTITY_TYPE *cn;
    /* PHYSICAL_LAYER_ENTITY_TYPE *src;*/

    Component *src;
    PDU_TYPE *pdu;
    int i;
{
         
	char * link;
	register Neighbor *n;
	register Component *c, *d;
	tick_t rtt;
	int j = cn->findindex[pdu->u.d_pdu.next_node];
	int k;
	tick_t notify_time, SigArr;
        tick_t collision, coll_time;
	int ud, coll_dist;
	float distance;
	int mm;
	 

	/* Destination id in pdu */
	c = cn->node[j].c;
	cn->node[i].d=c;
	

	if(M.doX) {
	
	start_sending_packet( (Component *)src, (Component *)c);
	}
      


   rtt = USECS_TO_TICKS(cn->cn_delay->u.d);
   

   cn->node[i].Node_Transmitting = TRUE;
   if (cn->node[i].Signal_Arrival_Time < ev_now() + rtt){
	notify_time = Maxm(ev_now(), cn->node[i].Signal_Arrival_Time);
	
	cn->node[i].coll = ev_enqueue(COLLISION_DETECT_NOTIFY, (Component *)cn, (Component *)cn,
		   notify_time, cn->cn_action, (PDU_TYPE *) pdu, (caddr_t)i);
   
        SigArr= cn->node[i].Signal_Arrival_Time;
	cn->Collision_On_Link = TRUE;
	cn->node[i].Collision_Detected  = TRUE;
	cn->node[i].Collision_Detection_Time = notify_time;
	cn->node[i].Last_Collision_Detect_Time = notify_time;

	/*
        strncpy(namecall, "Datdcoll1",10);  
	trace(cn,i);
	*/
   }
   
   cn->node[i].Signal_Arrival_Time = ev_now();

   for(k=1;k<=cn->num_nodes; k++) {
	if (k == i) continue;
	notify_time = ev_now() + cn->Propogation_Time[i][k];


 

	  if ((cn->node[k].Node_Transmitting) && 
	    ( notify_time< cn->node[k].EndTx + rtt)) {
	    

	    if(1){
	    /*
	    if ((!cn->node[k].Collision_Detected)
		|| (cn->node[k].Collision_Detected &&
		    ((ev_now() +  cn->Propogation_Time[i][k])
		     < cn->node[k].Collision_Detection_Time))) {
	  
		     */     
/* dequeue "check transmission status..." and collision detect*/
	       
	  if (cn->node[k].coll){
	    ev_dequeue(cn->node[k].coll);
	      cn->node[k].coll = NULL;  
	  }
	  if (cn->node[k].chtr){
	    ev_dequeue(cn->node[k].chtr);
	      cn->node[k].chtr = NULL;  
	  }
	  
	  
	  if( ((PHYSICAL_LAYER_ENTITY_TYPE *) src)->cn_prop_time->u.d > ((PHYSICAL_LAYER_ENTITY_TYPE *)cn->node[k].c)->cn_prop_time->u.d){
	    ud =(int)((PHYSICAL_LAYER_ENTITY_TYPE *) src)->cn_prop_time->u.d; 
	    collision =  (unsigned long)(USECS_TO_TICKS(ud) -  ( Maxm(ev_now(), SigArr) - ev_now())/2.0);
	   distance = collision/5000.0;
	    
	   
	  }
	  else {
	  ud =(int)((PHYSICAL_LAYER_ENTITY_TYPE *) src)->cn_prop_time->u.d; 
	     collision = (unsigned long)(USECS_TO_TICKS(ud) +  ( Maxm(ev_now(), SigArr) - ev_now())/2.0);
         distance = collision/5000.0;
	 
	 
	


	  }
	  
	   coll_dist=(int)(distance*1000);


 coll_time=(unsigned long) (( Maxm(ev_now(), SigArr) - ev_now())/2.0)+ ev_now();


    ev_enqueue(UPDATE_INTERFACE, (Component *)cn,
			    (Component *)cn, coll_time-100,
			    cn->cn_action, (PDU_TYPE *) NULL, (caddr_t)coll_dist);

	  ev_enqueue(COLLISION_DETECT_NOTIFY, (Component *)cn,
			    (Component *)cn, notify_time,
			    cn->cn_action, (PDU_TYPE *) pdu, (caddr_t)k);
   
		 cn->Collision_On_Link = TRUE;
		 if(!cn->node[k].Collision_Detected)
		      cn->node[k].Last_Collision_Detect_Time = notify_time;

		 cn->node[k].Collision_Detected = TRUE;
		 cn->node[k].Collision_Detection_Time = notify_time;

		 /*
		 trace(cn,k);*/
	    } /* IF */
	} /* IF */


   if (cn->node[k].Signal_Arrival_Time < ev_now()) /*Old signal*/
     cn->node[k].Tmp_Signal_Arrival_Time = 
       Minm (cn->node[k].Tmp_Signal_Arrival_Time, 
	     ev_now() + cn->Propogation_Time[i][k]);

   else 
     
	cn->node[k].Signal_Arrival_Time =
	     Minm(cn->node[k].Signal_Arrival_Time, notify_time); 
	
   } /* FOR */

/*   if(cn->Collision_On_Link && cn->Collision_Clear_Time > ev_now() + rtt) {
	 ev_enqueue(COLLISION_CLEAR, (Component *)cn, (Component *)cn,
		    (ev_now() + rtt),
		    cn->cn_action, (PDU_TYPE *) NULL, (caddr_t)NULL);
 	cn->Collision_Clear_Time = ev_now() + rtt;
    } */ /* IF */
 

   if(!cn->Collision_On_Link){
	cn->node[i].chtr = ev_enqueue(CHK_XMN_STATUS, (Component *)cn, (Component *)cn,
		   (ev_now() + rtt),
		   cn->cn_action, (PDU_TYPE *) pdu, (caddr_t)i);

	/* Assume all pkts = 128 bytes = 1024bits */
		cn->node[i].EndTx = ev_now() + USECS_TO_TICKS(102.4); 	

		/*	if(M.doX)
	start_sending_packet((Component *)cn, (Component *)c);
	*/
	

		/*
       strcpy(namecall,"IsTranssng");
       trace(cn,i);
       */
   }
		


/* $Revision$ : Errors later in Enet */
/* $Revision$: Testing deterministic drop policy */
/*   if (cn->cn_err->u.d > 0){
	cn->cn_accts = cn->cn_accts - 1.0;
	if (cn->cn_accts <= 0){
	     pdu->u.d_pdu.error = YES;
	     for (i=0;i<9;i++)
		  pdu->u.d_pdu.a_pdu.data[i] = 13;
	     cn->cn_accts = cn->cn_accts + cn->cn_one_by_err;
	}
   }
   */
   
/*   if (Cise_random()/((double) MAX_RANDOM_NUMBER)  < cn->cn_err->u.d )
     pdu->u.d_pdu.error = YES;
     */ 
/* Graphics later */
   
   /*
     if (M.doX) {
       char frame_type[32]="(unknown frame type)";
       switch (pdu->u.d_pdu.type) {
       case D_INFO: 
           sprintf(frame_type,"Info(%d)",pdu->u.d_pdu.seq_number); 
           break;
       case D_ACK:
           sprintf(frame_type,"ACK(%d)",pdu->u.d_pdu.ack_number); 
           break;
       case D_NAK:
           sprintf(frame_type,"NAK(%d)",pdu->u.d_pdu.ack_number); 
           break;
       }
       route_activity((Component *)cn, c, tics, 4, 0); 
       cise_st_event(pdu->u.d_pdu.curr_node,
		     pdu->u.d_pdu.next_node,
		     ev_now(), ev_now()+tics, frame_type,
		     pdu->u.d_pdu.error);
   }
   */
   
/*   ev_enqueue(EV_RECEIVE, (Component *)cn, c, ev_now()+tics,c->co_action,
	      (PDU_TYPE *) pdu, (caddr_t)NULL);
	      */   
   return ((caddr_t)cn);

}

/********************************************************************/

/********************************************************************/

static caddr_t
cn_update_interface(cn,coll_dist)
    register LINK_ENTITY_TYPE *cn;
    
    int coll_dist;
    
   
{

 int mm;
 
 float collision_distance=coll_dist/1000.0;
 

 

 for (mm=0;mm < MaxCollision;mm++){

	     

	       if(interface_array[mm]==-1.0){
	      interface_array[mm]=collision_distance;
	       break;
	    }

	  }






 




   return ((caddr_t)cn);    
}




/*******************************************************************/




















































