


/* $Log:	link.h,v $
 * Revision 1.4  96/08/29  10:21:14  shivkuma
 * More Mickey mouse fixes
 * 
 * Revision 1.3  96/08/27  14:01:57  shivkuma
 * More bugs in Mickey fixed
 * 
 * Revision 1.2  96/08/26  16:13:20  shivkuma
 * Added mickey mouse to lab3
 * 
 * Revision 1.1  96/07/12  20:51:28  tlin
 * Initial revision
 * 
 * Revision 1.0  96/04/24  14:54:44  shivkuma
 * Lab 1
 *  */

#ifndef LINK_H
#define LINK_H

#include "q.h"
#include "eventdefs.h"
#include "component.h"
#include "log.h"
#include "comptypes.h"
#include "pdu.h"
#include "event.h"
#include "route.h"
#include "subr.h"
#include "sim_tk.h"


typedef struct {
     Component *c;
     Component *d;
     tick_t Signal_Arrival_Time;
     tick_t Tmp_Signal_Arrival_Time;
     int    Waiting;
     int    Node_Transmitting;
     int    Collision_Detected;
     tick_t Collision_Detection_Time;
     tick_t Last_Collision_Detect_Time;
     tick_t EndTx;
     Event *coll;
     Event *chtr;
} Node_Type;


typedef struct _LINKConnectiont{
   struct _LINKConnectiont *cn_next, *cn_prev;
   short         cn_class;
   short         cn_type;
   char          cn_name[40];    /* Name of component (appears on screen) */
     PFP           cn_action;      /* Main function of component.  */
  XComponent    *cn_picture;     /* Graphics object that displays this thing */
  list          *cn_neighbors;  /* List of neighbors of this thing */

   /* Parameters-- data that will be displayed on screen */
   short         cn_menu_up;     /* If true, then the text window is up */
   short         cn_big_menu;     /* not used */
  queue         *cn_params;     /* Variable-length queue of parameters */

  int           cn_iq_length;    /* get the current input q length here */
  int           cn_iq_limit;    /* get the current input q length here */


  int           cn_flash;
  Param         *cn_Name;

  Param		*cn_delay;
  Param		*cn_err;

     double 	cn_accts; /* Error accounts: deterministic error based
			   on input probability */
    double 	cn_one_by_err;

     Node_Type node[MAXNODES];
     tick_t Propogation_Time[MAXNODES][MAXNODES];
     int Collision_On_Link;
     tick_t Collision_Clear_Time;
     int num_nodes;
     int findindex[MAXNODES];

} LINKConnectiont;

/* Use mutually exclusive numbers for self events */
#define CHK_XMN_STATUS (Evtype)(EV_CLASS_PRIVATE | 8)
#define COLLISION_DETECT_NOTIFY (Evtype)(EV_CLASS_PRIVATE | 9)
#define LINE_CLEAR_AFCOLL (Evtype)(EV_CLASS_PRIVATE | 10)
#define LINE_CLEAR_AFTRAN (Evtype)(EV_CLASS_PRIVATE | 11)
#define INFORM_MAC (Evtype)(EV_CLASS_PRIVATE | 12)
#define STOP_GRAPHIC (Evtype)(EV_CLASS_PRIVATE | 13)
#define UPDATE_INTERFACE (Evtype)(EV_CLASS_PRIVATE | 14)
caddr_t link_action(Component *src, LINKConnectiont *cn, int type, PDU_TYPE *pdu, caddr_t arg);

#endif
  











