/*  Do not modify this file */

#include "cisePort.h"
#include "sim.h"
#include "list.h"
#include "main.h"
#include "route_activity.h"
#include "physical_layer.h"
#include "subr.h"



#define DOTTED_LIST_LENGTH 2
#define DOT_DASHED_LIST_LENGTH 4
#define SHORT_DASHED_LIST_LENGTH 5
#define LONG_DASHED_LIST_LENGTH 2
#define ODD_DASHED_LIST_LENGTH 3
#define PHYSICAL_LAYER_ENTITY_TYPE PHYConnectiont
#define Data_Link_Connectiont PHYConnectiont


extern Log pkt_log;
extern int doXstuff;

static caddr_t cn_reset(), cn_start(), cn_create(),cn_neighbor(),
               cn_receive(),
               cn_uneighbor(),cn_route(),cn_hops(),cn_send(),
     cn_carrier_free(), cn_successful_xmit(),cn_collision_detect(),cn_retry();
static char * find_route();

static int update_phy_info(), UpdatePhyBuffer(), InsertPDUIntoPhyBuffer();
static  PDU_TYPE *GetPDUFromPhyBuffer();
static caddr_t retransmit();
double ran_num();
char *node_nmb();
char node_n[1];
 

#define phy_other_event_handlers()			\
{							\
  case EV_RESET:					\
       result=(caddr_t)cn_reset(cn);			\
       break;						\
  case EV_CREATE:					\
       result = cn_create((char *)arg);			\
       break; 						\
  case EV_DEL:						\
       comp_delete((Component *)cn);			\
       result = (caddr_t)cn;				\
       break;						\
  case EV_NEIGHBOR:					\
       result = cn_neighbor(cn, (Component *)arg);	\
       break;						\
  case EV_UNEIGHBOR:					\
       result = cn_uneighbor(cn, (Component *)arg);	\
       break;						\
  case EV_LEGAL_NEXT_HOPS:				\
       result = cn_hops(cn);				\
       break;						\
  case EV_MAKE_ROUTE:					\
       result = cn_route(cn, arg);	    	        \
       break;						\
  case EV_START: 					\
       result = cn_start(cn);                           \
       break;						\
  case EV_UPDATE_ROUTE_ACTIVITY:			\
       update_routes(src,(Component *)cn);              \
       result=(caddr_t)cn;				\
       break;						\
  case EV_UPDATE_BUS_ACTIVITY: 	                        \
       update_bus_routes(src,(Component *)cn, (int)arg);              \
       result=(caddr_t)cn;				\
       break;						\
case EV_DRAW_PACKET_FROM_BUS_TO_DEST_ACTIVITY:		\
       draw_packet_from_bus_to_dest(src,(Component *)cn, (int)arg);              \
       result=(caddr_t)cn;				\
       break;						\
  case INFORM_MAC:					\
       update_phy_info(cn,(int)arg);   \
       result=(caddr_t)cn;				\
       break;						\
}




caddr_t
physical_layer_action(src,cn1,type,pdu,arg)
     Component *src;
     void *cn1;
     int type;
     PDU_TYPE *pdu;
     caddr_t arg;

{

   caddr_t result = NULL;
   PHYSICAL_LAYER_ENTITY_TYPE *cn;

   cn = (PHYSICAL_LAYER_ENTITY_TYPE *)cn1;

   switch (type)  {

   case EV_RECEIVE:
        
	result = cn_receive(cn,src,pdu);
	break;

   case EV_CARRIER_FREE:
	result = cn_carrier_free(cn,src);
	break;

   case EV_SUCCESSFUL_XMIT:
	result = cn_successful_xmit(cn,src,pdu);
	break;

   case EV_COLLISION_DETECT:
	result = cn_collision_detect(cn);
	break;

   case RETRY_TRANSMISSION:
	result = cn_retry(cn);
	break;
	
   phy_other_event_handlers();

   default:
      break;


    }

  return(result);
}


















/****************************************/
static caddr_t
cn_create(name)
     register char *name;
{
    PHYConnectiont *newcn;

   /* Memory for the component structure. */
   newcn = (PHYConnectiont *)sim_malloc(sizeof(PHYConnectiont));

   /* First things first-- copy name into the new structure. */
   strncpy(newcn->cn_name, name, 40);

   /* have to create a neighbor list */
  newcn->cn_neighbors= l_create();
  newcn->cn_params = q_create();
  newcn->cn_type = PHYSICAL_LAYER_TYPE;
  newcn->cn_class = PHY_CLASS;
  newcn->cn_action = physical_layer_action;
  newcn->cn_menu_up = FALSE;
  newcn->cn_flash = 0;

 /* Initialize the parameters */
  newcn->cn_Name = param_init ((Component*)newcn, "Name",
             (PFD)NULL, (PFP)make_name_text, (PFP)make_short_name_text,
             param_input_name,
             0, DisplayMask | InputMask | CanHaveLogMask, 0.0);



 newcn->cn_prop_time = param_init((Component *)newcn,
            "Node Position in Bus (km)",
             (PFD)NULL,(PFP)make_double_text,(PFP)make_short_double_text,
             param_input_double,
             0,DisplayMask | InputMask, 0.0);
 newcn->cn_prop_time->u.d = 1.0 ; /* 1km = 5usecs */



 /*   KOT */



 newcn->cn_crt = l_create();

    return((caddr_t)newcn);
}

/****************************************/
static int
update_phy_info(cn,i)
 register PHYConnectiont *cn;
 register int i;
{
cn->cn_index = i;
return i;
}

/****************************************/
static caddr_t
cn_neighbor(cn,c)
     register PHYConnectiont *cn;
     register Component *c;
{
     register Neighbor *n;
    if (!(n=add_neighbor((Component*)cn,c,0,2,LINK_CLASS,DLC_CLASS)))
        return ((caddr_t)NULL);
    return ((caddr_t)n);
}
/****************************************/
static caddr_t
cn_reset(cn)
     register PHYConnectiont *cn;
{
 	Neighbor *n;


	cn->cn_prop_time->u.d *= 5; /* convert from km to usec */
	cn->numb_of_coll_per_frame=0;
	cn->max_numb_of_coll_per_frame=0;
        cn->tot_numb_of_coll_per_node=0;
	
	/* send to link */
      for (n=(Neighbor *)cn->cn_neighbors->l_head;n;n=n->n_next) {
	   if (n->n_c->co_class == LINK_CLASS)
		break;
      }

      
    
 ev_enqueue(INFORM_MAC, (Component *)cn,
      		  (Component *)(n->n_c),
		  ev_now()+1, n->n_c->co_action, (PDU_TYPE *) NULL,
		  (caddr_t) (USECS_TO_TICKS(cn->cn_prop_time->u.d)));

     return ((caddr_t)cn);
}
/****************************************/
static caddr_t
cn_start(cn)
     PHYConnectiont *cn;
{
     /* $Revision$ : Enet: Simple buffer management */
     cn->buffer.buffer_index = 0;
     cn->buffer.buffers_available = MAXBUFFERS;
	 cn->transmitting = FALSE;
     cn->carrier_sensing = FALSE;
     
     return ((caddr_t)cn);
}
/*****************************************/
static caddr_t
cn_uneighbor(cn,c)
   register PHYConnectiont *cn;
   register Component *c;
{
   return ((caddr_t)remove_neighbor((Component *)cn,c));
}

/******************************************/

static caddr_t
cn_hops(cn,l)
   register PHYConnectiont *cn;
   list *l;
{


    register list *nlist;
    register Neighbor *n;
    register Component *c;

/* what is legal for the next hop depends on the type of the previous
   hop. If the previous one is a link, then the next must be a connection.
   If the previous one is a connection, the next one may be either a link
   or a connection.
   (Allowing a connection with both ends at the same bte ) */

   /* The previous step in the route = tail of list is put in c */
   c = (Component *)(l->l_tail->le_data);

   /* Make an empty list */
   nlist = l_create();

   /* Put appropriate neighbors into list */
   for (n=(Neighbor *)cn->cn_neighbors->l_head;n;n=n->n_next)
       if (n->n_c!=c && ((c->co_class == DLC_CLASS) ||
           (c->co_class == LINK_CLASS && n->n_c->co_class == DLC_CLASS)))
            l_addt(nlist,(caddr_t)n->n_c);


    return ((caddr_t)nlist);


}

/****************************************** */

static int
get_number_from_string(p)
char *p;
{

while(!isdigit(*p)) p++;

return atoi(p);
}

/*******************************************/
#ifdef OBSOLETE_by_tlin_053196
static caddr_t
cn_route(cn,l)
         register PHYConnectiont *cn;
         list *l;
{

        l_elt * le;
	CRT *newroute;
	char dstr[10];

/* SHIV : CISE : 15th Feb */
/* l is the list of the components on the route; currently a phy-link-phy */
/* The link number is the unique id of the connection */
	newroute = (CRT *) malloc(sizeof(CRT));
 
	le  = l->l_head->le_next;   /* the source phy layer */ 

	le = le->le_next;          /* the link */
	strcpy(newroute->link,le->le_data);
	newroute->path_id = get_number_from_string(le->le_data);
	
	le = le->le_next;          /* the dest phy layer */
	newroute->dest = get_number_from_string(le->le_data);
	
 /* extract the num */

	l_addt(cn->cn_crt, (caddr_t) newroute);


	/* $Revision$: Enet: Dummy code beyond this point */

#ifdef NOTDEF
         Param *p;
         Component *this_component;
         Component *other_component;
         Neighbor *n1;
         Neighbor *n2;
    

         p=param_init((Component *)cn,"Other End Connection :               ",
                      int_calc,make_int_text,make_short_int_text,
                      (PFI)NULL,0,DisplayMask | CanHaveLogMask,0.0);

        if ((((Component *)route_list->l_head->le_data)->co_name[3] !=
              cn->cn_name[3]) || 
             (((Component *)route_list->l_head->le_data)->co_name[2] !=
              cn->cn_name[2]) || 
              (((Component *)route_list->l_head->le_data)->co_name[1] !=
              cn->cn_name[1]) || 
              (((Component *)route_list->l_head->le_data)->co_name[0] !=
              cn->cn_name[0]) ) 
            strcat(p->p_name,((Component *)route_list->l_head->le_data)->
                              co_name);
        else strcat(p->p_name,((Component *)route_list->l_tail->le_data)->
                               co_name);
 
         cn->cn_vpi=vpi;

         this_component = (Component *)route_list->l_head->le_data;
         other_component = (Component *)route_list->l_tail->le_data ;      

         n1= (Neighbor *)this_component->co_neighbors->l_head;
         n2= (Neighbor *)other_component->co_neighbors->l_head;

         if (n1->n_c->co_name[3] == n2->n_c->co_name[3])
            cn->cn_simple_connection=1;
         

           return ((caddr_t)cn); /* return something non-null */
#endif
}
#endif /* OBSOLETE_by_tlin_053196 */

/* $Revision$: Enet: New cn_route code by Tlin */

static caddr_t cn_route(cn,buf)
    register PHYConnectiont *cn;
    char     *buf;
{
    CRT *newroute;
    char link[33], dest[33];

/* SHIV : CISE : 15th Feb */
/* l is the list of the components on the route; currently a phy-link-phy */
/* The link number is the unique id of the connection */
    newroute = (CRT *) malloc(sizeof(CRT));

    sscanf(buf, "%32s%32s", link, dest);

    strcpy(newroute->link,link);                       /* the link */
    newroute->path_id = get_number_from_string(link);

    newroute->dest = get_number_from_string(dest);     /* the dest */
    
    l_addt(cn->cn_crt, (caddr_t) newroute);
}
 
/********************************************************************/


char * find_route(cn, dest)
register PHYConnectiont *cn;
int dest;
{
l_elt * le;


for (le = cn->cn_crt->l_head; le && ((CRT *)le->le_data)->dest != dest; le=le->le_next) ;

return((char *) (((CRT *)le->le_data)->link));

}
/********************************************************************/

/* Simple Buffer Management Routines */
static int 
InsertPDUIntoPhyBuffer(PHYConnectiont *cn, PDU_TYPE *pdu)
{
int i;


if (cn->buffer.buffers_available > 0){
     
     i = cn->buffer.buffer_index;
     cn->buffer.buffer_index =
	  ( cn->buffer.buffer_index + 1)%MAXBUFFERS;


     bcopy((char *)pdu,(char *)&(cn->buffer.buf[i]), sizeof(PDU_TYPE));

     cn->buffer.buffers_available--;

}
else {
     printf("Help: Phy layer buffer overflow");
     fflush(stdout);
}

/* No flow control of DLC layer provided here  */

pdu_free(pdu); 
return 0;
     
}

/****************************************/
static int
UpdatePhyBuffer(PHYConnectiont *cn)
{
     cn->buffer.buffers_available += 1; /* Buffers available */

return 0;
}
/****************************************/

#define DataInPhyBuffer(cn) (MAXBUFFERS - cn->buffer.buffers_available)

/****************************************/

static PDU_TYPE *
GetPDUFromPhyBuffer(PHYConnectiont *cn)
{
int i;

i = ( cn->buffer.buffer_index + cn->buffer.buffers_available )%MAXBUFFERS;

return (&(cn->buffer.buf[i]));
}

/********************************************************************/
/********************************************************************/
/********************************************************************/
/********************************************************************/
static caddr_t
cn_receive(cn,src, p)
    register PHYSICAL_LAYER_ENTITY_TYPE *cn;
    Component *src;
    PDU_TYPE *p;
{

	int dest;
	char * link;
	Neighbor *n;
	PDU_TYPE *pdu;
	
 if (src->co_class == DLC_CLASS) {

      /* $Revision$: Enet: Buffer management routines */
      InsertPDUIntoPhyBuffer(cn,p);

      if(!cn->carrier_sensing && !cn->transmitting){
	   pdu = GetPDUFromPhyBuffer(cn);
      
      /* find the right link */

	   dest = pdu->u.d_pdu.next_node;
	   link = find_route(cn,dest);

	   
      /* send to link */
	   for (n=(Neighbor *)cn->cn_neighbors->l_head;n;n=n->n_next) {
		if (n->n_c->co_class == LINK_CLASS && 
		    strcmp(n->n_c->co_name,link) == 0)
		     break;
	   }
          
	   ev_enqueue(EV_CARRIER_SENSE, (Component *)cn, n->n_c, ev_now(),
		      n->n_c->co_action, (PDU_TYPE *) pdu,
		      (caddr_t)(cn->cn_index));
	   cn->carrier_sensing = TRUE;
      }
	

/*	if (cn->cn_flash) { cn->cn_flash = 0; } 
        else { cn->cn_flash = 1; } 

	if (M.doX)
	    route_activity((Component *)cn, n->n_c, 10, 3, 0);
		   */
	

 } else if (src->co_class == LINK_CLASS) {



	/* send to dlc */
        for (n=(Neighbor *)cn->cn_neighbors->l_head;n;n=n->n_next) {
                 if (n->n_c->co_class == DLC_CLASS)
                     break;
        }
	/*
	if (M.doX)
	     route_activity((Component *)cn, n->n_c, 10, 3, 0); 
	     */
	     ev_enqueue(EV_RECEIVE, (Component *)cn, n->n_c, 
			ev_now()+10,n->n_c->co_action,
			(PDU_TYPE *) p, (caddr_t)NULL);
	     
                        
	   
 }
   return ((caddr_t)cn);
}


/********************************************************************/
static caddr_t
cn_carrier_free(cn,src)
    register PHYSICAL_LAYER_ENTITY_TYPE *cn;
   

    Component *src;
{
    PDU_TYPE *pdu;
    PDU_TYPE *p;
    int i,j;
    Component *d;
    PHYSICAL_LAYER_ENTITY_TYPE *ck;
    
    cn->carrier_sensing = FALSE;

    /* Assume that you have data to send */
    /* $Revision$: Enet: Attempt to send immediately */
    p = GetPDUFromPhyBuffer(cn);
    pdu = pdu_alloc();
    bcopy((char *)p, (char *)pdu, sizeof(PDU_TYPE));
    
   

    ev_enqueue(EV_RECEIVE, (Component *)cn, (Component *)src, ev_now(),
	       src->co_action, (PDU_TYPE *) pdu, (caddr_t)(cn->cn_index));
   
    /*
      j = pdu->u.d_pdu.next_node;

      ck=cn;
      for(i=1;i<=10;i++){
	if (isdigit((Component *)(ck->cn_next)->co_name)==j)
		    break;
	ck=ck->cn_next;
      }
	
      */

     
	
     cn->transmitting = TRUE;
     return ((caddr_t)cn);
}
/********************************************************************/
static caddr_t
cn_successful_xmit(cn,src,pp)
    register PHYSICAL_LAYER_ENTITY_TYPE *cn;
    /*register LINK_ENTITY_TYPE *src;*/
    Component *src;
    PDU_TYPE *pp;
{
   PDU_TYPE *pdu;
    PDU_TYPE *p;
    /*Component *cc;*/ 
      int jj = pp->u.d_pdu.next_node;
      /* Try to send more data if available */
     /* $Revision$: Same effect is gotten thru carrier free signal
	which comes in immediately */
  /*  Update buffers first */
      

     UpdatePhyBuffer(cn);
    
     cn->numb_of_coll_per_frame=0; /*Put 0 the number  of ...*/
     
      /* This event then has the effect of a carrier free signal */
     /* cn->carrier_sensing = FALSE; */
  cn->transmitting = FALSE;   
  if(!cn->carrier_sensing && DataInPhyBuffer(cn)) {
	  p = GetPDUFromPhyBuffer(cn);
	  pdu = pdu_alloc();
	  bcopy((char *)p, (char *)pdu, sizeof(PDU_TYPE));
	  
	   ev_enqueue(EV_CARRIER_SENSE, (Component *)cn, (Component *)src,
		     ev_now()+ USECS_TO_TICKS(100), src->co_action, (PDU_TYPE *) NULL,
		     (caddr_t)(cn->cn_index));
	  cn->carrier_sensing = TRUE;
	}

     return ((caddr_t)cn);
}

/********************************************************************/
static caddr_t
cn_retry(cn)
    register PHYSICAL_LAYER_ENTITY_TYPE *cn;
   
{
 
     int dest;
     char * link;
     Neighbor *n;
     PDU_TYPE *pdu;

    pdu = GetPDUFromPhyBuffer(cn);
      
    /* find the right link */

    dest = pdu->u.d_pdu.next_node;
    link = find_route(cn,dest);


    /* send to link */
    for (n=(Neighbor *)cn->cn_neighbors->l_head;n;n=n->n_next) {
	 if (n->n_c->co_class == LINK_CLASS && 
	     strcmp(n->n_c->co_name,link) == 0)
	      break; 
    }

    if(!cn->carrier_sensing){
	 ev_enqueue(EV_CARRIER_SENSE, (Component *)cn, n->n_c, ev_now(),
		    n->n_c->co_action, (PDU_TYPE *) NULL,
		    (caddr_t)(cn->cn_index));
	 cn->carrier_sensing = TRUE;
    }
       
	  
	

    return ((caddr_t)cn);
	
}
/********************************************************************/

static caddr_t
retransmit(cn,t)
    register PHYSICAL_LAYER_ENTITY_TYPE *cn;
    tick_t t;


{

 cn->carrier_sensing = FALSE;
     ev_enqueue(RETRY_TRANSMISSION, (Component *)cn, (Component *)cn,
			ev_now() + t, cn->cn_action, (PDU_TYPE *) NULL,
			(caddr_t)NULL);



return ((caddr_t)cn);

}

double ran_num()

{

 return ((double)Cise_random()/((double) MAX_RANDOM_NUMBER));


}


char *node_nmb(cn)
 register PHYSICAL_LAYER_ENTITY_TYPE *cn;



{

 


  strcpy(node_n,((Component*)cn)->co_name+3);



  return (node_n);

}

















