/* route.c,v 1.0 1993/10/21 19:12:20 NIST golmie */
/* SHIV : cleaned up for CISE */
/*
 *
 * $Log: route.c,v $
 * Revision 4.0  1996/08/23 20:02:27  tlin
 * bump to mickey mouse version
 *
 * Revision 3.1  1996/06/02 20:49:17  tlin
 * foo
 *
 * Revision 3.0  1996/05/30 14:40:54  tlin
 * bump to 3.0; before Tk adition
 *
 * Revision 2.3  1996/05/29 17:24:11  tlin
 * ptrototype rt_create()
 *
 * Revision 2.2  1996/05/29 16:20:20  tlin
 * dgb_write() redo
 *
 * Revision 2.1  1996/05/28 05:57:31  tlin
 * bump to v 2.1; before tcl/tk conversion
 *
 * Revision 0.1  1996/05/27 22:51:40  tlin
 * test
 *
 * Revision 0.0  96/04/26  15:34:30  goyal
 * Lab1
 * 
 * Revision 1.0  96/04/24  15:02:01  shivkuma
 * Lab 1
 * 
 * Revision 1.1  96/04/22  00:00:05  shivkuma
 * Version Before Putting in User-Friendly names
 * 
 * Revision 0.0  96/02/21  00:44:03  goyal
 * Initial Revision
 * 
 *
 *
 */


/* Centralized routing table.  Rather than having each component that needs
   to do so keep a routing table, this module keeps the routing table
   for the whole simulator.  */

#include "cisePort.h"
#include "sim.h"
#include "list.h"
#include "hash.h"
#include "component.h"
#include "log.h"
#include "comptypes.h"
#include "eventdefs.h"
#include "pdu.h"
#include "route.h"


/* Routines:
   rt_create()		Create & initialize the table.
   rt_destroy()		Destroy the routing table.
   rt_make_route()	Insert a new route into the table, checking
   			for its legality.
   rt_delete_route()	Delete a route, given either of its conections.
   rt_find_route()	Given either connection, return its route.
   rt_is_in_route()	Given a component, see if it is in any route.
   rt_lookup()		Given a destination socket & a component,
   			look up the next component & next hop.
*/

/* Will only use for now rt_lookup, the rest is done local 
   to the switch - 9-8-1993 */

/* The table */
Htable routing_table = NULL;

/* Initialize the routing table. */
int rt_create()
{
  /* Don't do anything if it is already there */
  if (routing_table)
    return(FALSE);

  /* Create this baby--size is a random prime number */
  routing_table = ht_create(1117, sizeof(Route_key), sizeof(Route_rec));

  return(TRUE);
}


/* Wipe out the table & all it contains */
void
rt_destroy()
{
  Route_key *rk;
  Route_rec *rr;
  char *p;

/* Additions 8-19-1993 */
/* For now no-op */
  /* First look through entire table & free all the lists
     of routes contained therein. */
/*
  ht_iter_setup(routing_table);
  while (p = ht_iter(routing_table))  {
*/
    /* Muck about to get a pointer to the record */
/*
    rk = (Route_key *)p;
    rr = (Route_rec *)(p + sizeof(Route_key));
*/
    /* Only free the list if the component in the key == the comp at
       the head of the route.  This ensures that list is only freed once.*/
/*
    if (rk->rk_current_comp == (Component *)rr->rr_route->l_head->le_data)
      lq_delete(rr->rr_route);
  }
*/
  /* Now wipe the table */
/*
  ht_obliterate(routing_table);
  routing_table = NULL;
*/
/* End Additions */
}

/* Additions 8-19-1993 */
/*
Route_info *
rt_lookup(c,s)
*/
/*     Component *c; */		/* Component that is asking */
/*     Socket *s;	*/		/* Final destination socket */
/*
{
  Route_key rk;
  Route_rec *rr;

  rk.rk_socket.so_port = s->so_port;
  rk.rk_socket.so_host = s->so_host;
  rk.rk_current_comp = c;

  rr = (Route_rec *)ht_find(routing_table, (char *)&rk);

  if (!rr)
    return(NULL);

  return((Route_info *)&(rr->rr_info));
}
*/

/* SHIV : CISE : unsure */ Route_info * rt_lookup(c,/* CISE : vpi,*/routing_table)
/* 9-8-1993 */
     Component *c;
/*     VPI vpi; */
     Htable routing_table;
{
     Route_key rk;
     Route_rec *rr;

/*     rk.rk_vpi = vpi; */
     rk.rk_last_link = c;
     rr = (Route_rec *)ht_find(routing_table,(char *)&rk);

     if (!rr) return (NULL);
     
     return((Route_info *)&(rr->rr_info));
}
/* End Additions */



rt_make_route(l, oneway)
     list *l;
     int oneway;
{
  Route_key rk;
  Route_rec rr;
  l_elt *le;
  int result;

/* Additions 8-19-1993 */
  /* Simple check--are both head & tail connections ? */
/*
  if (((Component *)l->l_head->le_data)->co_class != CONNECTION ||
      ((Component *)l->l_tail->le_data)->co_class != CONNECTION)  {
      dbg_write(DBG_ERR, NULL,
		"rt_make_route: route does not have connection at both ends");
      return(FALSE);
  }
  */

  /* Otherwise, assume that enough other checking has been done so that
     the route is correct.  (It's easier to check the route while
     building the list anyway :-) */
/*
  rr.rr_route = l;
*/

  /* Step forward through the route, inserting new records into the table. */
/*
  rk.rk_socket.so_port = (Component *)l->l_tail->le_data;
  rk.rk_socket.so_host = (Component *)l->l_tail->le_prev->le_data;
  for (le = l->l_head; le; le = le->le_next)  {
    rk.rk_current_comp = (Component *)le->le_data;
    rr.rr_info.next_hop = rr.rr_info.next_link = NULL;
    if (le->le_next)  {
      rr.rr_info.next_link = (Component *)le->le_next->le_data;
      if (le->le_next->le_next)
	rr.rr_info.next_hop = (Component *)le->le_next->le_next->le_data;
    }
    result = ht_insert(routing_table, (char *)&rk, (char *)&rr);
    if (result == -1)  {
#ifdef DEBUG
      dbg_write(debug_log, DBG_INFO, (Component *)NULL,
		"rt_make_route: ht_insert failed--routing loop");
#endif
    }
  }
*/
  /* And now backwards. (If allowed) */
/*
  if (!oneway)  {
    rk.rk_socket.so_port = (Component *)l->l_head->le_data;
    rk.rk_socket.so_host = (Component *)l->l_head->le_next->le_data;
    for (le = l->l_tail; le; le = le->le_prev)  {
      rk.rk_current_comp = (Component *)le->le_data;
      rr.rr_info.next_hop = rr.rr_info.next_link = NULL;
      if (le->le_prev)  {
	rr.rr_info.next_link = (Component *)le->le_prev->le_data;
	if (le->le_prev->le_prev)
	  rr.rr_info.next_hop = (Component *)le->le_prev->le_prev->le_data;
      }
      result = ht_insert(routing_table, (char *)&rk, (char *)&rr);
      if (result == -1)  {
#ifdef DEBUG
	dbg_write(debug_log, DBG_INFO, (Component *)NULL,
		  "rt_make_route: ht_insert failed--routing loop");
#endif
      }
    }
  }
*/

  /* And that's it */

/* End Additions */
  return(TRUE);
}


/* Given a connection, delete the route associated with it from the table */
rt_delete_route(c)
     Component *c;
{
  char *p;
  Route_key *rk;
  Route_rec *rr;
  list *routel;

  routel = rt_find_route(c);
  if (!routel)  {
      dbg_write(DBG_ERR, NULL, "rt_delete_route: rt_find_route failed");
      return(FALSE);
  }

  /* We now have the list.  Iterate over the table & delete all entries
     that have this list in it.  */
  ht_iter_setup(routing_table);
  while (p = ht_iter(routing_table))  {
      rk = (Route_key *)p;
      rr = (Route_rec *)(p + sizeof(Route_key));
      if (rr->rr_route == routel)  {
	  if (!ht_delete(routing_table, (char *)rk))  {
	      dbg_write(DBG_ERR, NULL, "rt_delete_route: ht_delete failed");
	  }
      }
  }
  /* Get rid of the list */
  lq_delete(routel);

  return(TRUE);
}



/* Find the route associated with some connection */
list *
rt_find_route(c)
     Component *c;
{
  Route_key rk;
  Route_rec *rr;

/* Additions 8-19-1993 */

  /* If it isn't a connection, die */
/*
  if (c->co_class != CONNECTION)  {
#ifdef DEBUG
    dbg_write(debug_log, DBG_ERR, (Component *)NULL,
	      "rt_find_route: passed component is not a connection");
#endif
    return(NULL);
  }
*/
  /* Call the component's action routine to get the other socket */
/* End Additions */
return(NULL);
}


/* Determine whether a component is currently used in any route.
   Return the first route found.  */
list *
rt_is_in_route(c)
     Component *c;
{
  Route_key *rk;
  Route_rec *rr;
  char *p;

/* Additions 8-19-1993 */
/*
  ht_iter_setup(routing_table);
  while (p = ht_iter(routing_table))  {
    rk = (Route_key *)p;
    rr = (Route_rec *)(p + sizeof(Route_key));
    if (rk->rk_current_comp == c)
      return(rr->rr_route);
  }
*/
/* End Additions */
  return(NULL);
}
