

/*
   $Log: sim_tk.C,v $
   Revision 4.0  1996/08/23 20:02:27  tlin
   bump to mickey mouse version

   Revision 1.12  1996/06/03 03:19:38  tlin
   foo

   Revision 1.11  1996/06/03 01:01:57  tlin
   foo

   Revision 1.10  1996/06/03 00:45:48  tlin
   neighbor relationship is shown on canvas

   Revision 1.9  1996/06/02 20:52:40  tlin
   foo

   Revision 1.8  1996/06/02 19:57:34  tlin
   foo

   Revision 1.7  1996/06/02 17:51:04  tlin
   workaable, phase 1

   Revision 1.6  1996/06/01 06:31:56  tlin
   finish icon_xxx()

   Revision 1.5  1996/06/01 06:25:13  tlin
   hook to icon_app is working better

   Revision 1.4  1996/06/01 05:48:36  tlin
   add char *name to icon_xxx()

   Revision 1.3  1996/06/01 03:07:41  tlin
   ready to use interp for Tcl

   Revision 1.2  1996/06/01 02:23:22  tlin
   function without body is ready

   Revision 1.1  1996/06/01 02:20:35  tlin
   Initial revision

   */

/* Tk inclusion for CISE -- tlin@cis  */

#include "cisePort.h"
extern "C" {
#include "sim.h"
#include "list.h"
#include "main.h"
#include "component.h"
#include "sim_tk.h"
}


/*
 *  Draw Bus
 */
XComponent*  draw_bus(Component *co, char *type, int x, int y)
{
    char       buf[100];
    XComponent *xc=(XComponent*)sim_malloc(sizeof(XComponent));
    
    xc->x=x; xc->y=y; xc->w=xc->h=30;
    sprintf(buf, "draw_bus %s %s %d %d", co->co_name, type, x, y);
    Tcl_Eval(M.interp, buf);
    return xc;
}


XComponent* make_icon(Component *co, char *type, int x, int y)
{
    char       buf[100];
    XComponent *xc=(XComponent*)sim_malloc(sizeof(XComponent));
    
    xc->x=x; xc->y=y; xc->w=xc->h=30;
    sprintf(buf, "make_icon %s %s %d %d", co->co_name, type, x, y);
    Tcl_Eval(M.interp, buf);
    return xc;
}


XComponent* icon_app(Component *co, int x, int y)
{
    return make_icon(co, "app", x, y);
}

XComponent* icon_dlc(Component *co, int x, int y)
{
    return make_icon(co, "dlc", x, y);
}

XComponent* icon_phy(Component *co, int x, int y)
{
    return make_icon(co, "phy", x, y);
}

XComponent* icon_link(Component *co, int x, int y)
{
  /* make_icon(co, "link", x, y); */
    return draw_bus(co, "link", x, y);
}




/*
 *  Because it seems that co_type is not used in the code although existing in the
 *  data structure. I adopt the very stupid mehtod to detect the line between bus(link)
 *  and phyical layer.
 *  
 *  It is need to be modified later.
 */

int show_neighbor_relation(Component *c1, Component *c2)
{
    XComponent *xc1=c1->co_picture;
    XComponent *xc2=c2->co_picture;
    char       buf[200];

   
    if ((strcmp(c1->co_name, "phy1")==0 && strcmp(c2->co_name, "link1")==0) ||
	(strcmp(c1->co_name, "phy2")==0 && strcmp(c2->co_name, "link1")==0) ||
	(strcmp(c1->co_name, "phy3")==0 && strcmp(c2->co_name, "link1")==0)) {

      sprintf(buf, "show_neighbor_relation %d %d %d %d %s %s", 
	    xc1->x, xc1->y, xc1->bus_x ,xc1->bus_y, c1->co_name, "bus");
    } else if ((strcmp(c1->co_name, "link1")==0 && strcmp(c2->co_name, "phy1")==0) ||
	       (strcmp(c1->co_name, "link1")==0 && strcmp(c2->co_name, "phy2")==0) ||
	       (strcmp(c1->co_name, "link1")==0 && strcmp(c2->co_name, "phy3")==0)) {
      
      sprintf(buf, "show_neighbor_relation %d %d %d %d %s %s", 
	     xc2->bus_x ,xc2->bus_y, xc2->x, xc2->y, "bus", c2->co_name);
    } else {
      sprintf(buf, "show_neighbor_relation %d %d %d %d %s %s", 
	     xc1->x, xc1->y, xc2->x, xc2->y, c1->co_name, c2->co_name);
    }
    Tcl_Eval(M.interp, buf);

   	return 0;
}

/*
 * Input: Physical Layer
 * 
 *        Physical Layer knows that the (x,y) coordination itself.
 *        and the bus postion it is belong to.
 *
 * Note: Suppose I have know where the bus postion is (x,700)
 */
int show_bus_relation(Component *c1)
{
    XComponent *xc1=c1->co_picture;
    char       buf[200];

    // Suppose I have known the "bus position" 
    // 700: the y coordination is the 700th pixel

    sprintf(buf, "show_neighbor_relation %d %d %d %d %s %s", 
	    xc1->x, xc1->y, xc1->bus_x ,xc1->bus_y, c1->co_name, "bus");
    Tcl_Eval(M.interp, buf);

	return 0;
}

/*
 *   Draw Packet, Delete Packet
 *
 */

int draw_packet(char *name, char* color, int x, int y, int blockW, int blockH)
{
   char       buf[200];

   sprintf(buf, "draw_packet %s %s %d %d %d %d", 
	    name, color, x, y, blockW, blockH);
   Tcl_Eval(M.interp, buf);

   return 0;
}

int delete_packet(char *name, int x, int y)
{
   char       buf[200];

   sprintf(buf, "delete_packet %s %d %d", name, x, y );
   Tcl_Eval(M.interp, buf);


   return 0;
}

int delete_all_packet()
{
    char       buf[200];

    sprintf(buf, "delete_all_packet");
    Tcl_Eval(M.interp, buf);

	return 0;
}









